/*
 * Ported from Flashlight VNC ActionScript implementation:
 *     http://www.wizhelp.com/flashlight-vnc/
 *
 * Full attribution follows:
 *
 * -------------------------------------------------------------------------
 *
 * This DES class has been extracted from package Acme.Crypto for use in VNC.
 * The unnecessary odd parity code has been removed.
 *
 * These changes are:
 *  Copyright (C) 1999 AT&T Laboratories Cambridge.  All Rights Reserved.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *

 * DesCipher - the DES encryption method
 *
 * The meat of this code is by Dave Zimmerman <dzimm@widget.com>, and is:
 *
 * Copyright (c) 1996 Widget Workshop, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL or COMMERCIAL purposes and
 * without fee is hereby granted, provided that this copyright notice is kept 
 * intact. 
 * 
 * WIDGET WORKSHOP MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. WIDGET WORKSHOP SHALL NOT BE LIABLE
 * FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  WIDGET WORKSHOP
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 *
 * The rest is:
 *
 * Copyright (C) 1996 by Jef Poskanzer <jef@acme.com>.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Visit the ACME Labs Java page for up-to-date versions of this and other
 * fine Java utilities: http://www.acme.com/java/
 */
"use strict";function DES(e){function t(e){var t,a,i,o,r,n,s,d,c,l,u=[],_=[],f=[];for(a=0,i=56;56>a;++a,i-=8)i+=-5>i?65:-3>i?31:-1>i?63:27===i?35:0,o=7&i,u[a]=0!==(e[i>>>3]&1<<o)?1:0;for(t=0;16>t;++t){for(o=t<<1,r=o+1,f[o]=f[r]=0,n=28;59>n;n+=28)for(a=n-28;n>a;++a)i=a+g[t],_[a]=n>i?u[i]:u[i-28];for(a=0;24>a;++a)0!==_[$[a]]&&(f[o]|=1<<23-a),0!==_[$[a+24]]&&(f[r]|=1<<23-a)}for(t=0,c=0,l=0;16>t;++t)s=f[c++],d=f[c++],y[l]=(16515072&s)<<6,y[l]|=(4032&s)<<10,y[l]|=(16515072&d)>>>10,y[l]|=(4032&d)>>>6,++l,y[l]=(258048&s)<<12,y[l]|=(63&s)<<16,y[l]|=(258048&d)>>>4,y[l]|=63&d,++l}function a(e){var t,a,i,o,r=0,n=e.slice(),s=0;for(a=n[r++]<<24|n[r++]<<16|n[r++]<<8|n[r++],i=n[r++]<<24|n[r++]<<16|n[r++]<<8|n[r++],o=252645135&(a>>>4^i),i^=o,a^=o<<4,o=65535&(a>>>16^i),i^=o,a^=o<<16,o=858993459&(i>>>2^a),a^=o,i^=o<<2,o=16711935&(i>>>8^a),a^=o,i^=o<<8,i=i<<1|i>>>31&1,o=2863311530&(a^i),a^=o,i^=o,a=a<<1|a>>>31&1,r=0;8>r;++r)o=i<<28|i>>>4,o^=y[s++],t=v[63&o],t|=p[o>>>8&63],t|=_[o>>>16&63],t|=l[o>>>24&63],o=i^y[s++],t|=h[63&o],t|=m[o>>>8&63],t|=f[o>>>16&63],t|=u[o>>>24&63],a^=t,o=a<<28|a>>>4,o^=y[s++],t=v[63&o],t|=p[o>>>8&63],t|=_[o>>>16&63],t|=l[o>>>24&63],o=a^y[s++],t|=h[63&o],t|=m[o>>>8&63],t|=f[o>>>16&63],t|=u[o>>>24&63],i^=t;for(i=i<<31|i>>>1,o=2863311530&(a^i),a^=o,i^=o,a=a<<31|a>>>1,o=16711935&(a>>>8^i),i^=o,a^=o<<8,o=858993459&(a>>>2^i),i^=o,a^=o<<2,o=65535&(i>>>16^a),a^=o,i^=o<<16,o=252645135&(i>>>4^a),a^=o,i^=o<<4,o=[i,a],r=0;8>r;r++)n[r]=(o[r>>>2]>>>8*(3-r%4))%256,n[r]<0&&(n[r]+=256);return n}function i(e){return a(e.slice(0,8)).concat(a(e.slice(8,16)))}var o,r,n,s,d,c,l,u,_,f,p,m,v,h,$=[13,16,10,23,0,4,2,27,14,5,20,9,22,18,11,3,25,7,15,6,26,19,12,1,40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,28,31],g=[1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28],b=0,y=[];return o=65536,r=1<<24,n=o|r,s=4,d=1024,c=s|d,l=[n|d,b|b,o|b,n|c,n|s,o|c,b|s,o|b,b|d,n|d,n|c,b|d,r|c,n|s,r|b,b|s,b|c,r|d,r|d,o|d,o|d,n|b,n|b,r|c,o|s,r|s,r|s,o|s,b|b,b|c,o|c,r|b,o|b,n|c,b|s,n|b,n|d,r|b,r|b,b|d,n|s,o|b,o|d,r|s,b|d,b|s,r|c,o|c,n|c,o|s,n|b,r|c,r|s,b|c,o|c,n|d,b|c,r|d,r|d,b|b,o|s,o|d,b|b,n|s],o=1<<20,r=1<<31,n=o|r,s=32,d=32768,c=s|d,u=[n|c,r|d,b|d,o|c,o|b,b|s,n|s,r|c,r|s,n|c,n|d,r|b,r|d,o|b,b|s,n|s,o|d,o|s,r|c,b|b,r|b,b|d,o|c,n|b,o|s,r|s,b|b,o|d,b|c,n|d,n|b,b|c,b|b,o|c,n|s,o|b,r|c,n|b,n|d,b|d,n|b,r|d,b|s,n|c,o|c,b|s,b|d,r|b,b|c,n|d,o|b,r|s,o|s,r|c,r|s,o|s,o|d,b|b,r|d,b|c,r|b,n|s,n|c,o|d],o=1<<17,r=1<<27,n=o|r,s=8,d=512,c=s|d,_=[b|c,n|d,b|b,n|s,r|d,b|b,o|c,r|d,o|s,r|s,r|s,o|b,n|c,o|s,n|b,b|c,r|b,b|s,n|d,b|d,o|d,n|b,n|s,o|c,r|c,o|d,o|b,r|c,b|s,n|c,b|d,r|b,n|d,r|b,o|s,b|c,o|b,n|d,r|d,b|b,b|d,o|s,n|c,r|d,r|s,b|d,b|b,n|s,r|c,o|b,r|b,n|c,b|s,o|c,o|d,r|s,n|b,r|c,b|c,n|b,o|c,b|s,n|s,o|d],o=8192,r=1<<23,n=o|r,s=1,d=128,c=s|d,f=[n|s,o|c,o|c,b|d,n|d,r|c,r|s,o|s,b|b,n|b,n|b,n|c,b|c,b|b,r|d,r|s,b|s,o|b,r|b,n|s,b|d,r|b,o|s,o|d,r|c,b|s,o|d,r|d,o|b,n|d,n|c,b|c,r|d,r|s,n|b,n|c,b|c,b|b,b|b,n|b,o|d,r|d,r|c,b|s,n|s,o|c,o|c,b|d,n|c,b|c,b|s,o|b,r|s,o|s,n|d,r|c,o|s,o|d,r|b,n|s,b|d,r|b,o|b,n|d],o=1<<25,r=1<<30,n=o|r,s=256,d=1<<19,c=s|d,p=[b|s,o|c,o|d,n|s,b|d,b|s,r|b,o|d,r|c,b|d,o|s,r|c,n|s,n|d,b|c,r|b,o|b,r|d,r|d,b|b,r|s,n|c,n|c,o|s,n|d,r|s,b|b,n|b,o|c,o|b,n|b,b|c,b|d,n|s,b|s,o|b,r|b,o|d,n|s,r|c,o|s,r|b,n|d,o|c,r|c,b|s,o|b,n|d,n|c,b|c,n|b,n|c,o|d,b|b,r|d,n|b,b|c,o|s,r|s,b|d,b|b,r|d,o|c,r|s],o=1<<22,r=1<<29,n=o|r,s=16,d=16384,c=s|d,m=[r|s,n|b,b|d,n|c,n|b,b|s,n|c,o|b,r|d,o|c,o|b,r|s,o|s,r|d,r|b,b|c,b|b,o|s,r|c,b|d,o|d,r|c,b|s,n|s,n|s,b|b,o|c,n|d,b|c,o|d,n|d,r|b,r|d,b|s,n|s,o|d,n|c,o|b,b|c,r|s,o|b,r|d,r|b,b|c,r|s,n|c,o|d,n|b,o|c,n|d,b|b,n|s,b|s,b|d,n|b,o|c,b|d,o|s,r|c,b|b,n|d,r|b,o|s,r|c],o=1<<21,r=1<<26,n=o|r,s=2,d=2048,c=s|d,v=[o|b,n|s,r|c,b|b,b|d,r|c,o|c,n|d,n|c,o|b,b|b,r|s,b|s,r|b,n|s,b|c,r|d,o|c,o|s,r|d,r|s,n|b,n|d,o|s,n|b,b|d,b|c,n|c,o|d,b|s,r|b,o|d,r|b,o|d,o|b,r|c,r|c,n|s,n|s,b|s,o|s,r|b,r|d,o|b,n|d,b|c,o|c,n|d,b|c,r|s,n|c,n|b,o|d,b|b,b|s,n|c,b|b,o|c,n|b,b|d,r|s,r|d,b|d,o|s],o=1<<18,r=1<<28,n=o|r,s=64,d=4096,c=s|d,h=[r|c,b|d,o|b,n|c,r|b,r|c,b|s,r|b,o|s,n|b,n|c,o|d,n|d,o|c,b|d,b|s,n|b,r|s,r|d,b|c,o|d,o|s,n|s,n|d,b|c,b|b,b|b,n|s,r|s,r|d,o|c,o|b,o|c,o|b,n|d,b|d,b|s,n|s,b|d,o|c,r|d,b|s,r|s,n|b,n|s,r|b,o|b,r|c,b|b,n|c,o|s,r|s,n|b,r|d,r|c,b|b,n|c,o|d,o|d,b|c,b|c,o|s,r|b,n|d],t(e),{encrypt:i}}